'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

const index = require('./index-3c56ce3c.js');
const _commonjsHelpers = require('./_commonjsHelpers-b3309d7b.js');
const utils = require('./utils-2c2d17bf.js');
const v4 = require('./v4-078aedb1.js');

var datepicker_min = {exports: {}};

(function (module, exports) {
!function(e,t){module.exports=t();}(window,(function(){return function(e){var t={};function n(a){if(t[a])return t[a].exports;var r=t[a]={i:a,l:!1,exports:{}};return e[a].call(r.exports,r,r.exports,n),r.l=!0,r.exports}return n.m=e,n.c=t,n.d=function(e,t,a){n.o(e,t)||Object.defineProperty(e,t,{enumerable:!0,get:a});},n.r=function(e){"undefined"!=typeof Symbol&&Symbol.toStringTag&&Object.defineProperty(e,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(e,"__esModule",{value:!0});},n.t=function(e,t){if(1&t&&(e=n(e)),8&t)return e;if(4&t&&"object"==typeof e&&e&&e.__esModule)return e;var a=Object.create(null);if(n.r(a),Object.defineProperty(a,"default",{enumerable:!0,value:e}),2&t&&"string"!=typeof e)for(var r in e)n.d(a,r,function(t){return e[t]}.bind(null,r));return a},n.n=function(e){var t=e&&e.__esModule?function(){return e.default}:function(){return e};return n.d(t,"a",t),t},n.o=function(e,t){return Object.prototype.hasOwnProperty.call(e,t)},n.p="",n(n.s=0)}([function(e,t,n){n.r(t);var a=[],r=["Sun","Mon","Tue","Wed","Thu","Fri","Sat"],i=["January","February","March","April","May","June","July","August","September","October","November","December"],o={t:"top",r:"right",b:"bottom",l:"left",c:"centered"};function s(){}var l=["click","focusin","keydown","input"];function d(e){l.forEach((function(t){e.addEventListener(t,e===document?L:Y);}));}function c(e){return Array.isArray(e)?e.map(c):"[object Object]"===x(e)?Object.keys(e).reduce((function(t,n){return t[n]=c(e[n]),t}),{}):e}function u(e,t){var n=e.calendar.querySelector(".qs-overlay"),a=n&&!n.classList.contains("qs-hidden");t=t||new Date(e.currentYear,e.currentMonth),e.calendar.innerHTML=[h(t,e,a),f(t,e,a),v(e,a)].join(""),a&&window.requestAnimationFrame((function(){M(!0,e);}));}function h(e,t,n){return ['<div class="qs-controls'+(n?" qs-blur":"")+'">','<div class="qs-arrow qs-left"></div>','<div class="qs-month-year'+(t.disableYearOverlay?" qs-disabled-year-overlay":"")+'">','<span class="qs-month">'+t.months[e.getMonth()]+"</span>",'<span class="qs-year">'+e.getFullYear()+"</span>","</div>",'<div class="qs-arrow qs-right"></div>',"</div>"].join("")}function f(e,t,n){var a=t.currentMonth,r=t.currentYear,i=t.dateSelected,o=t.maxDate,s=t.minDate,l=t.showAllDates,d=t.days,c=t.disabledDates,u=t.startDay,h=t.weekendIndices,f=t.events,v=t.getRange?t.getRange():{},m=+v.start,y=+v.end,p=g(new Date(e).setDate(1)),w=p.getDay()-u,D=w<0?7:0;p.setMonth(p.getMonth()+1),p.setDate(0);var b=p.getDate(),q=[],S=D+7*((w+b)/7|0);S+=(w+b)%7?7:0;for(var M=1;M<=S;M++){var E=(M-1)%7,x=d[E],C=M-(w>=0?w:7+w),L=new Date(r,a,C),Y=f[+L],j=C<1||C>b,O=j?C<1?-1:1:0,P=j&&!l,k=P?"":L.getDate(),N=+L==+i,_=E===h[0]||E===h[1],I=m!==y,A="qs-square "+x;Y&&!P&&(A+=" qs-event"),j&&(A+=" qs-outside-current-month"),!l&&j||(A+=" qs-num"),N&&(A+=" qs-active"),(c[+L]||t.disabler(L)||_&&t.noWeekends||s&&+L<+s||o&&+L>+o)&&!P&&(A+=" qs-disabled"),+g(new Date)==+L&&(A+=" qs-current"),+L===m&&y&&I&&(A+=" qs-range-start"),+L>m&&+L<y&&(A+=" qs-range-middle"),+L===y&&m&&I&&(A+=" qs-range-end"),P&&(A+=" qs-empty",k=""),q.push('<div class="'+A+'" data-direction="'+O+'">'+k+"</div>");}var R=d.map((function(e){return '<div class="qs-square qs-day">'+e+"</div>"})).concat(q);return R.unshift('<div class="qs-squares'+(n?" qs-blur":"")+'">'),R.push("</div>"),R.join("")}function v(e,t){var n=e.overlayPlaceholder,a=e.overlayButton;return ['<div class="qs-overlay'+(t?"":" qs-hidden")+'">',"<div>",'<input class="qs-overlay-year" placeholder="'+n+'" inputmode="numeric" />','<div class="qs-close">&#10005;</div>',"</div>",'<div class="qs-overlay-month-container">'+e.overlayMonths.map((function(e,t){return '<div class="qs-overlay-month" data-month-num="'+t+'">'+e+"</div>"})).join("")+"</div>",'<div class="qs-submit qs-disabled">'+a+"</div>","</div>"].join("")}function m(e,t,n){var a=t.el,r=t.calendar.querySelector(".qs-active"),i=e.textContent,o=t.sibling;(a.disabled||a.readOnly)&&t.respectDisabledReadOnly||(t.dateSelected=n?void 0:new Date(t.currentYear,t.currentMonth,i),r&&r.classList.remove("qs-active"),n||e.classList.add("qs-active"),p(a,t,n),n||q(t),o&&(y({instance:t,deselect:n}),t.first&&!o.dateSelected&&(o.currentYear=t.currentYear,o.currentMonth=t.currentMonth,o.currentMonthName=t.currentMonthName),u(t),u(o)),t.onSelect(t,n?void 0:new Date(t.dateSelected)));}function y(e){var t=e.instance.first?e.instance:e.instance.sibling,n=t.sibling;t===e.instance?e.deselect?(t.minDate=t.originalMinDate,n.minDate=n.originalMinDate):n.minDate=t.dateSelected:e.deselect?(n.maxDate=n.originalMaxDate,t.maxDate=t.originalMaxDate):t.maxDate=n.dateSelected;}function p(e,t,n){if(!t.nonInput)return n?e.value="":t.formatter!==s?t.formatter(e,t.dateSelected,t):void(e.value=t.dateSelected.toDateString())}function w(e,t,n,a){n||a?(n&&(t.currentYear=+n),a&&(t.currentMonth=+a)):(t.currentMonth+=e.contains("qs-right")?1:-1,12===t.currentMonth?(t.currentMonth=0,t.currentYear++):-1===t.currentMonth&&(t.currentMonth=11,t.currentYear--)),t.currentMonthName=t.months[t.currentMonth],u(t),t.onMonthChange(t);}function D(e){if(!e.noPosition){var t=e.position.top,n=e.position.right;if(e.position.centered)return e.calendarContainer.classList.add("qs-centered");var a=e.positionedEl.getBoundingClientRect(),r=e.el.getBoundingClientRect(),i=e.calendarContainer.getBoundingClientRect(),o=r.top-a.top+(t?-1*i.height:r.height)+"px",s=r.left-a.left+(n?r.width-i.width:0)+"px";e.calendarContainer.style.setProperty("top",o),e.calendarContainer.style.setProperty("left",s);}}function b(e){return "[object Date]"===x(e)&&"Invalid Date"!==e.toString()}function g(e){if(b(e)||"number"==typeof e&&!isNaN(e)){var t=new Date(+e);return new Date(t.getFullYear(),t.getMonth(),t.getDate())}}function q(e){e.disabled||!e.calendarContainer.classList.contains("qs-hidden")&&!e.alwaysShow&&("overlay"!==e.defaultView&&M(!0,e),e.calendarContainer.classList.add("qs-hidden"),e.onHide(e));}function S(e){e.disabled||(e.calendarContainer.classList.remove("qs-hidden"),"overlay"===e.defaultView&&M(!1,e),D(e),e.onShow(e));}function M(e,t){var n=t.calendar,a=n.querySelector(".qs-overlay"),r=a.querySelector(".qs-overlay-year"),i=n.querySelector(".qs-controls"),o=n.querySelector(".qs-squares");e?(a.classList.add("qs-hidden"),i.classList.remove("qs-blur"),o.classList.remove("qs-blur"),r.value=""):(a.classList.remove("qs-hidden"),i.classList.add("qs-blur"),o.classList.add("qs-blur"),r.focus());}function E(e,t,n,a){var r=isNaN(+(new Date).setFullYear(t.value||void 0)),i=r?null:t.value;if(13===e.which||13===e.keyCode||"click"===e.type)a?w(null,n,i,a):r||t.classList.contains("qs-disabled")||w(null,n,i);else if(n.calendar.contains(t)){n.calendar.querySelector(".qs-submit").classList[r?"add":"remove"]("qs-disabled");}}function x(e){return {}.toString.call(e)}function C(e){a.forEach((function(t){t!==e&&q(t);}));}function L(e){if(!e.__qs_shadow_dom){var t=e.which||e.keyCode,n=e.type,r=e.target,o=r.classList,s=a.filter((function(e){return e.calendar.contains(r)||e.el===r}))[0],l=s&&s.calendar.contains(r);if(!(s&&s.isMobile&&s.disableMobile))if("click"===n){if(!s)return a.forEach(q);if(s.disabled)return;var d=s.calendar,c=s.calendarContainer,h=s.disableYearOverlay,f=s.nonInput,v=d.querySelector(".qs-overlay-year"),y=!!d.querySelector(".qs-hidden"),p=d.querySelector(".qs-month-year").contains(r),D=r.dataset.monthNum;if(s.noPosition&&!l)(c.classList.contains("qs-hidden")?S:q)(s);else if(o.contains("qs-arrow"))w(o,s);else if(p||o.contains("qs-close"))h||M(!y,s);else if(D)E(e,v,s,D);else {if(o.contains("qs-disabled"))return;if(o.contains("qs-num")){var b=r.textContent,g=+r.dataset.direction,x=new Date(s.currentYear,s.currentMonth+g,b);if(g){s.currentYear=x.getFullYear(),s.currentMonth=x.getMonth(),s.currentMonthName=i[s.currentMonth],u(s);for(var L,Y=s.calendar.querySelectorAll('[data-direction="0"]'),j=0;!L;){var O=Y[j];O.textContent===b&&(L=O),j++;}r=L;}return void(+x==+s.dateSelected?m(r,s,!0):r.classList.contains("qs-disabled")||m(r,s))}o.contains("qs-submit")?E(e,v,s):f&&r===s.el&&(S(s),C(s));}}else if("focusin"===n&&s)S(s),C(s);else if("keydown"===n&&9===t&&s)q(s);else if("keydown"===n&&s&&!s.disabled){var P=!s.calendar.querySelector(".qs-overlay").classList.contains("qs-hidden");13===t&&P&&l?E(e,r,s):27===t&&P&&l&&M(!0,s);}else if("input"===n){if(!s||!s.calendar.contains(r))return;var k=s.calendar.querySelector(".qs-submit"),N=r.value.split("").reduce((function(e,t){return e||"0"!==t?e+(t.match(/[0-9]/)?t:""):""}),"").slice(0,4);r.value=N,k.classList[4===N.length?"remove":"add"]("qs-disabled");}}}function Y(e){L(e),e.__qs_shadow_dom=!0;}function j(e,t){l.forEach((function(n){e.removeEventListener(n,t);}));}function O(){S(this);}function P(){q(this);}function k(e,t){var n=g(e),a=this.currentYear,r=this.currentMonth,i=this.sibling;if(null==e)return this.dateSelected=void 0,p(this.el,this,!0),i&&(y({instance:this,deselect:!0}),u(i)),u(this),this;if(!b(e))throw new Error("`setDate` needs a JavaScript Date object.");if(this.disabledDates[+n]||n<this.minDate||n>this.maxDate)throw new Error("You can't manually set a date that's disabled.");this.dateSelected=n,t&&(this.currentYear=n.getFullYear(),this.currentMonth=n.getMonth(),this.currentMonthName=this.months[n.getMonth()]),p(this.el,this),i&&(y({instance:this}),u(i));var o=a===n.getFullYear()&&r===n.getMonth();return o||t?u(this,n):o||u(this,new Date(a,r,1)),this}function N(e){return I(this,e,!0)}function _(e){return I(this,e)}function I(e,t,n){var a=e.dateSelected,r=e.first,i=e.sibling,o=e.minDate,s=e.maxDate,l=g(t),d=n?"Min":"Max";function c(){return "original"+d+"Date"}function h(){return d.toLowerCase()+"Date"}function f(){return "set"+d}function v(){throw new Error("Out-of-range date passed to "+f())}if(null==t)e[c()]=void 0,i?(i[c()]=void 0,n?(r&&!a||!r&&!i.dateSelected)&&(e.minDate=void 0,i.minDate=void 0):(r&&!i.dateSelected||!r&&!a)&&(e.maxDate=void 0,i.maxDate=void 0)):e[h()]=void 0;else {if(!b(t))throw new Error("Invalid date passed to "+f());i?((r&&n&&l>(a||s)||r&&!n&&l<(i.dateSelected||o)||!r&&n&&l>(i.dateSelected||s)||!r&&!n&&l<(a||o))&&v(),e[c()]=l,i[c()]=l,(n&&(r&&!a||!r&&!i.dateSelected)||!n&&(r&&!i.dateSelected||!r&&!a))&&(e[h()]=l,i[h()]=l)):((n&&l>(a||s)||!n&&l<(a||o))&&v(),e[h()]=l);}return i&&u(i),u(e),e}function A(){var e=this.first?this:this.sibling,t=e.sibling;return {start:e.dateSelected,end:t.dateSelected}}function R(){var e=this.shadowDom,t=this.positionedEl,n=this.calendarContainer,r=this.sibling,i=this;this.inlinePosition&&(a.some((function(e){return e!==i&&e.positionedEl===t}))||t.style.setProperty("position",null));n.remove(),a=a.filter((function(e){return e!==i})),r&&delete r.sibling,a.length||j(document,L);var o=a.some((function(t){return t.shadowDom===e}));for(var s in e&&!o&&j(e,Y),this)delete this[s];a.length||l.forEach((function(e){document.removeEventListener(e,L);}));}function F(e,t){var n=new Date(e);if(!b(n))throw new Error("Invalid date passed to `navigate`");this.currentYear=n.getFullYear(),this.currentMonth=n.getMonth(),u(this),t&&this.onMonthChange(this);}function B(){var e=!this.calendarContainer.classList.contains("qs-hidden"),t=!this.calendarContainer.querySelector(".qs-overlay").classList.contains("qs-hidden");e&&M(t,this);}t.default=function(e,t){var n=function(e,t){var n,l,d=function(e){var t=c(e);t.events&&(t.events=t.events.reduce((function(e,t){if(!b(t))throw new Error('"options.events" must only contain valid JavaScript Date objects.');return e[+g(t)]=!0,e}),{}));["startDate","dateSelected","minDate","maxDate"].forEach((function(e){var n=t[e];if(n&&!b(n))throw new Error('"options.'+e+'" needs to be a valid JavaScript Date object.');t[e]=g(n);}));var n=t.position,i=t.maxDate,l=t.minDate,d=t.dateSelected,u=t.overlayPlaceholder,h=t.overlayButton,f=t.startDay,v=t.id;if(t.startDate=g(t.startDate||d||new Date),t.disabledDates=(t.disabledDates||[]).reduce((function(e,t){var n=+g(t);if(!b(t))throw new Error('You supplied an invalid date to "options.disabledDates".');if(n===+g(d))throw new Error('"disabledDates" cannot contain the same date as "dateSelected".');return e[n]=1,e}),{}),t.hasOwnProperty("id")&&null==v)throw new Error("`id` cannot be `null` or `undefined`");if(null!=v){var m=a.filter((function(e){return e.id===v}));if(m.length>1)throw new Error("Only two datepickers can share an id.");m.length?(t.second=!0,t.sibling=m[0]):t.first=!0;}var y=["tr","tl","br","bl","c"].some((function(e){return n===e}));if(n&&!y)throw new Error('"options.position" must be one of the following: tl, tr, bl, br, or c.');function p(e){throw new Error('"dateSelected" in options is '+(e?"less":"greater")+' than "'+(e||"max")+'Date".')}if(t.position=function(e){var t=e[0],n=e[1],a={};a[o[t]]=1,n&&(a[o[n]]=1);return a}(n||"bl"),i<l)throw new Error('"maxDate" in options is less than "minDate".');d&&(l>d&&p("min"),i<d&&p());if(["onSelect","onShow","onHide","onMonthChange","formatter","disabler"].forEach((function(e){"function"!=typeof t[e]&&(t[e]=s);})),["customDays","customMonths","customOverlayMonths"].forEach((function(e,n){var a=t[e],r=n?12:7;if(a){if(!Array.isArray(a)||a.length!==r||a.some((function(e){return "string"!=typeof e})))throw new Error('"'+e+'" must be an array with '+r+" strings.");t[n?n<2?"months":"overlayMonths":"days"]=a;}})),f&&f>0&&f<7){var w=(t.customDays||r).slice(),D=w.splice(0,f);t.customDays=w.concat(D),t.startDay=+f,t.weekendIndices=[w.length-1,w.length];}else t.startDay=0,t.weekendIndices=[6,0];"string"!=typeof u&&delete t.overlayPlaceholder;"string"!=typeof h&&delete t.overlayButton;var q=t.defaultView;if(q&&"calendar"!==q&&"overlay"!==q)throw new Error('options.defaultView must either be "calendar" or "overlay".');return t.defaultView=q||"calendar",t}(t||{startDate:g(new Date),position:"bl",defaultView:"calendar"}),u=e;if("string"==typeof u)u="#"===u[0]?document.getElementById(u.slice(1)):document.querySelector(u);else {if("[object ShadowRoot]"===x(u))throw new Error("Using a shadow DOM as your selector is not supported.");for(var h,f=u.parentNode;!h;){var v=x(f);"[object HTMLDocument]"===v?h=!0:"[object ShadowRoot]"===v?(h=!0,n=f,l=f.host):f=f.parentNode;}}if(!u)throw new Error("No selector / element found.");if(a.some((function(e){return e.el===u})))throw new Error("A datepicker already exists on that element.");var m=u===document.body,y=n?u.parentElement||n:m?document.body:u.parentElement,w=n?u.parentElement||l:y,D=document.createElement("div"),q=document.createElement("div");D.className="qs-datepicker-container qs-hidden",q.className="qs-datepicker";var M={shadowDom:n,customElement:l,positionedEl:w,el:u,parent:y,nonInput:"INPUT"!==u.nodeName,noPosition:m,position:!m&&d.position,startDate:d.startDate,dateSelected:d.dateSelected,disabledDates:d.disabledDates,minDate:d.minDate,maxDate:d.maxDate,noWeekends:!!d.noWeekends,weekendIndices:d.weekendIndices,calendarContainer:D,calendar:q,currentMonth:(d.startDate||d.dateSelected).getMonth(),currentMonthName:(d.months||i)[(d.startDate||d.dateSelected).getMonth()],currentYear:(d.startDate||d.dateSelected).getFullYear(),events:d.events||{},defaultView:d.defaultView,setDate:k,remove:R,setMin:N,setMax:_,show:O,hide:P,navigate:F,toggleOverlay:B,onSelect:d.onSelect,onShow:d.onShow,onHide:d.onHide,onMonthChange:d.onMonthChange,formatter:d.formatter,disabler:d.disabler,months:d.months||i,days:d.customDays||r,startDay:d.startDay,overlayMonths:d.overlayMonths||(d.months||i).map((function(e){return e.slice(0,3)})),overlayPlaceholder:d.overlayPlaceholder||"4-digit year",overlayButton:d.overlayButton||"Submit",disableYearOverlay:!!d.disableYearOverlay,disableMobile:!!d.disableMobile,isMobile:"ontouchstart"in window,alwaysShow:!!d.alwaysShow,id:d.id,showAllDates:!!d.showAllDates,respectDisabledReadOnly:!!d.respectDisabledReadOnly,first:d.first,second:d.second};if(d.sibling){var E=d.sibling,C=M,L=E.minDate||C.minDate,Y=E.maxDate||C.maxDate;C.sibling=E,E.sibling=C,E.minDate=L,E.maxDate=Y,C.minDate=L,C.maxDate=Y,E.originalMinDate=L,E.originalMaxDate=Y,C.originalMinDate=L,C.originalMaxDate=Y,E.getRange=A,C.getRange=A;}d.dateSelected&&p(u,M);var j=getComputedStyle(w).position;m||j&&"static"!==j||(M.inlinePosition=!0,w.style.setProperty("position","relative"));var I=a.filter((function(e){return e.positionedEl===M.positionedEl}));I.some((function(e){return e.inlinePosition}))&&(M.inlinePosition=!0,I.forEach((function(e){e.inlinePosition=!0;})));D.appendChild(q),y.appendChild(D),M.alwaysShow&&S(M);return M}(e,t);if(a.length||d(document),n.shadowDom&&(a.some((function(e){return e.shadowDom===n.shadowDom}))||d(n.shadowDom)),a.push(n),n.second){var l=n.sibling;y({instance:n,deselect:!n.dateSelected}),y({instance:l,deselect:!l.dateSelected}),u(l);}return u(n,n.startDate||n.dateSelected),n.alwaysShow&&D(n),n};}]).default}));
}(datepicker_min));

const datepicker = /*@__PURE__*/_commonjsHelpers.getDefaultExportFromCjs(datepicker_min.exports);

const fdiDateTimePickerCss = ".qs-datepicker-container{font-size:1rem;font-family:sans-serif;color:#000;position:absolute;width:15.625em;display:-webkit-box;display:-ms-flexbox;display:flex;-webkit-box-orient:vertical;-webkit-box-direction:normal;-ms-flex-direction:column;flex-direction:column;z-index:9001;-webkit-user-select:none;-moz-user-select:none;-ms-user-select:none;user-select:none;border:1px solid grey;border-radius:.263921875em;overflow:hidden;background:#fff;-webkit-box-shadow:0 1.25em 1.25em -.9375em rgba(0,0,0,.3);box-shadow:0 1.25em 1.25em -.9375em rgba(0,0,0,.3)}.qs-datepicker-container *{-webkit-box-sizing:border-box;box-sizing:border-box}.qs-centered{position:fixed;top:50%;left:50%;-webkit-transform:translate(-50%,-50%);-ms-transform:translate(-50%,-50%);transform:translate(-50%,-50%)}.qs-hidden{display:none}.qs-overlay{position:absolute;top:0;left:0;background:rgba(0,0,0,.75);color:#fff;width:100%;height:100%;padding:.5em;z-index:1;opacity:1;-webkit-transition:opacity .3s;transition:opacity .3s;display:-webkit-box;display:-ms-flexbox;display:flex;-webkit-box-orient:vertical;-webkit-box-direction:normal;-ms-flex-direction:column;flex-direction:column}.qs-overlay.qs-hidden{opacity:0;z-index:-1}.qs-overlay .qs-overlay-year{background:rgba(0,0,0,0);border:none;border-bottom:1px solid #fff;border-radius:0;color:#fff;font-size:.875em;padding:.25em 0;width:80%;text-align:center;margin:0 auto;display:block}.qs-overlay .qs-overlay-year::-webkit-inner-spin-button{-webkit-appearance:none}.qs-overlay .qs-close{padding:.5em;cursor:pointer;position:absolute;top:0;right:0}.qs-overlay .qs-submit{border:1px solid #fff;border-radius:.263921875em;padding:.5em;margin:0 auto auto;cursor:pointer;background:hsla(0,0%,50.2%,.4)}.qs-overlay .qs-submit.qs-disabled{color:grey;border-color:grey;cursor:not-allowed}.qs-overlay .qs-overlay-month-container{display:-webkit-box;display:-ms-flexbox;display:flex;-ms-flex-wrap:wrap;flex-wrap:wrap;-webkit-box-flex:1;-ms-flex-positive:1;flex-grow:1}.qs-overlay .qs-overlay-month{display:-webkit-box;display:-ms-flexbox;display:flex;-webkit-box-pack:center;-ms-flex-pack:center;justify-content:center;-webkit-box-align:center;-ms-flex-align:center;align-items:center;width:calc(100% / 3);cursor:pointer;opacity:.5;-webkit-transition:opacity .15s;transition:opacity .15s}.qs-overlay .qs-overlay-month.active,.qs-overlay .qs-overlay-month:hover{opacity:1}.qs-controls{width:100%;display:-webkit-box;display:-ms-flexbox;display:flex;-webkit-box-pack:justify;-ms-flex-pack:justify;justify-content:space-between;-webkit-box-align:center;-ms-flex-align:center;align-items:center;-webkit-box-flex:1;-ms-flex-positive:1;flex-grow:1;-ms-flex-negative:0;flex-shrink:0;background:#d3d3d3;-webkit-filter:blur(0);filter:blur(0);-webkit-transition:-webkit-filter .3s;transition:-webkit-filter .3s;transition:filter .3s;transition:filter .3s, -webkit-filter .3s}.qs-controls.qs-blur{-webkit-filter:blur(5px);filter:blur(5px)}.qs-arrow{height:1.5625em;width:1.5625em;position:relative;cursor:pointer;border-radius:.263921875em;-webkit-transition:background .15s;transition:background .15s}.qs-arrow:hover{background:rgba(0,0,0,.1)}.qs-arrow:hover.qs-left:after{border-right-color:#000}.qs-arrow:hover.qs-right:after{border-left-color:#000}.qs-arrow:after{content:\"\";border:.390625em solid rgba(0,0,0,0);position:absolute;top:50%;-webkit-transition:border .2s;transition:border .2s}.qs-arrow.qs-left:after{border-right-color:grey;right:50%;-webkit-transform:translate(25%,-50%);-ms-transform:translate(25%,-50%);transform:translate(25%,-50%)}.qs-arrow.qs-right:after{border-left-color:grey;left:50%;-webkit-transform:translate(-25%,-50%);-ms-transform:translate(-25%,-50%);transform:translate(-25%,-50%)}.qs-month-year{font-weight:700;-webkit-transition:border .2s;transition:border .2s;border-bottom:1px solid rgba(0,0,0,0)}.qs-month-year:not(.qs-disabled-year-overlay){cursor:pointer}.qs-month-year:not(.qs-disabled-year-overlay):hover{border-bottom:1px solid grey}.qs-month-year:active:focus,.qs-month-year:focus{outline:none}.qs-month{padding-right:.5ex}.qs-year{padding-left:.5ex}.qs-squares{display:-webkit-box;display:-ms-flexbox;display:flex;-ms-flex-wrap:wrap;flex-wrap:wrap;padding:.3125em;-webkit-filter:blur(0);filter:blur(0);-webkit-transition:-webkit-filter .3s;transition:-webkit-filter .3s;transition:filter .3s;transition:filter .3s, -webkit-filter .3s}.qs-squares.qs-blur{-webkit-filter:blur(5px);filter:blur(5px)}.qs-square{width:calc(100% / 7);height:1.5625em;display:-webkit-box;display:-ms-flexbox;display:flex;-webkit-box-align:center;-ms-flex-align:center;align-items:center;-webkit-box-pack:center;-ms-flex-pack:center;justify-content:center;cursor:pointer;-webkit-transition:background .1s;transition:background .1s;border-radius:.263921875em}.qs-square:not(.qs-empty):not(.qs-disabled):not(.qs-day):not(.qs-active):hover{background:orange}.qs-current{font-weight:700;text-decoration:underline}.qs-active,.qs-range-end,.qs-range-start{background:#add8e6}.qs-range-start:not(.qs-range-6){border-top-right-radius:0;border-bottom-right-radius:0}.qs-range-middle{background:#d4ebf2}.qs-range-middle:not(.qs-range-0):not(.qs-range-6){border-radius:0}.qs-range-middle.qs-range-0{border-top-right-radius:0;border-bottom-right-radius:0}.qs-range-end:not(.qs-range-0),.qs-range-middle.qs-range-6{border-top-left-radius:0;border-bottom-left-radius:0}.qs-disabled,.qs-outside-current-month{opacity:.2}.qs-disabled{cursor:not-allowed}.qs-day,.qs-empty{cursor:default}.qs-day{font-weight:700;color:grey}.qs-event{position:relative}.qs-event:after{content:\"\";position:absolute;width:.46875em;height:.46875em;border-radius:50%;background:#07f;bottom:0;right:0}";
const FdiDateTimePickerStyle0 = fdiDateTimePickerCss;

const FdiDateTimePicker = class {
    constructor(hostRef) {
        index.registerInstance(this, hostRef);
        this.dateTimeChanged = index.createEvent(this, "fdi_wc_datetimepicker_change", 7);
        this.__settings = undefined;
        this.__datetime = undefined;
        this.__dateonly = false;
        this.picker = undefined;
        this.date = undefined;
        this.time = '1:00';
        this.station = 'PM';
        this.timezone = 'None';
        this.settings = {
            meta: {}
        };
    }
    componentDidLoad() {
        const datetime = new Date();
        const [date, time, station, timezone] = this.__datetime ? this.__datetime.split(' ') : [undefined, undefined, undefined, undefined];
        if (time) {
            this.time = time;
        }
        if (station) {
            this.station = station;
        }
        if (timezone) {
            this.timezone = timezone;
        }
        const today = new Date(datetime.getFullYear(), datetime.getMonth(), datetime.getDate());
        this.date = date ? date : today.toLocaleDateString();
        this.picker = datepicker(this.element.shadowRoot.getElementById('datepicker'), {
            minDate: today,
            dateSelected: this.date ? new Date(this.date) : today,
            formatter: (input, date) => {
                input.value = date.toLocaleDateString();
            },
            onSelect: (instance, date) => {
                this.date = date.toLocaleDateString();
                console.log({ value: this.getValue(), instance });
                this.dateTimeChanged.emit({
                    newValue: this.getValue(),
                    meta: this.settings.meta,
                });
            }
        });
        this.dateTimeChanged.emit({
            newValue: this.getValue(),
            meta: this.settings.meta,
        });
    }
    getValue() {
        return this.__dateonly ? this.date.trim() : `${this.date} ${this.time} ${this.station} ${this.timezone}`.trim();
    }
    handleTimezoneChange(e) {
        this.timezone = e.target.value;
        this.dateTimeChanged.emit({
            newValue: this.getValue(),
            meta: this.settings.meta,
        });
    }
    handleStationChange(e) {
        this.station = e.target.value;
        this.dateTimeChanged.emit({
            newValue: this.getValue(),
            meta: this.settings.meta,
        });
    }
    handleTimeChange(e) {
        this.time = e.target.value;
        this.dateTimeChanged.emit({
            newValue: this.getValue(),
            meta: this.settings.meta,
        });
    }
    componentWillLoad() {
        let settings = this.__settings;
        if (typeof settings === 'string') {
            settings = JSON.parse(this.__settings);
        }
        this.settings = utils.overrideSettings(this.settings, settings);
    }
    render() {
        const availableTimes = [];
        const hours = 12;
        const minutes = [
            '00',
            15,
            30,
            45
        ];
        for (let i = 1; i <= hours; i++) {
            minutes.forEach(minute => {
                availableTimes.push(`${i}:${minute}`);
            });
        }
        return (index.h("div", { key: '15bc009c8c48d1e040a6da472f2e994eea788c47' }, index.h("input", { key: '4e68b21081d970e917473b17bd3abe733a97e93e', id: 'datepicker', placeholder: 'Select Date' }), !this.__dateonly &&
            index.h("select", { key: '5fcc2c88bf427e2abab751955d93eeb974934470', name: "time", id: "time", onInput: e => { this.handleTimeChange(e); } }, availableTimes.map(time => index.h("option", { value: time, selected: this.time === time }, time))), !this.__dateonly &&
            index.h("select", { key: 'c72cff565297b706a8e9614562390aaba91db764', name: "station", id: "station", onInput: e => { this.handleStationChange(e); } }, index.h("option", { key: 'b7c35cc2c29066a78a1e3f90ce2dc4004dfc29ac', value: 'PM', selected: this.station === 'PM' }, "PM"), index.h("option", { key: 'fd6a88a114daeb022137b9e6235593a02a10c7be', value: 'AM', selected: this.station === 'AM' }, "AM")), !this.__dateonly &&
            index.h("select", { key: '27898f39e38bf19a9bc7649d32622aacc144c25a', name: "timezone", id: "timezone", onInput: e => { this.handleTimezoneChange(e); } }, index.h("option", { key: '1f501e315f9538a6d238cedb1a1ef35f48d84be1', value: 'None', selected: this.timezone === 'None' }, "No Timezone"), index.h("option", { key: '3423fa2b50deb9d7e54684ac8c47c173c69c12e3', value: 'America/Los_Angeles', selected: this.timezone === 'America/Los_Angeles' }, "Pacific"), index.h("option", { key: '772353fb6ed9f4752b552e7b5abac9fb2b61e8d9', value: 'America/New_York', selected: this.timezone === 'America/New_York' }, "Eastern"), index.h("option", { key: '6c42d13b1373c28f5327e472cead966f6b3ad9fd', value: 'America/Denver', selected: this.timezone === 'America/Denver' }, "Mountain"), index.h("option", { key: '54666e4f1a9eb9e7ae4ca787107aacb8c4af2d14', value: 'America/Chicago', selected: this.timezone === 'America/Chicago' }, "Central"), index.h("option", { key: 'd71b70f1924b1d9c5034c42801240135b747c03f', value: 'America/Anchorage', selected: this.timezone === 'America/Anchorage' }, "Alaskan"), index.h("option", { key: 'ecd5f1d73f27b591693a97d1099374b5321bd459', value: 'America/Adak', selected: this.timezone === 'America/Adak' }, "Hawaiian"), index.h("option", { key: '66ea4949c8af6b86b73e88806a96504915213a42', value: 'America/Halifax', selected: this.timezone === 'America/Halifax' }, "Atlantic"), index.h("option", { key: '1af6f201e30cbeee2b314029e412dfd59f20075a', value: 'America/St_Johns', selected: this.timezone === 'America/St_Johns' }, "New Foundland"))));
    }
    get element() { return index.getElement(this); }
};
FdiDateTimePicker.style = FdiDateTimePickerStyle0;

const fdiImageUploaderCss = "#image_uploader_preview{max-width:500px;max-height:500px}";
const FdiImageUploaderStyle0 = fdiImageUploaderCss;

const FdiImageUploader = class {
    constructor(hostRef) {
        index.registerInstance(this, hostRef);
        this.imageUploader = index.createEvent(this, "fdi_wc_image_uploader_load", 7);
        this.__settings = undefined;
        this.__value = undefined;
        this.src = undefined;
        this.settings = {
            meta: {},
        };
    }
    emitData() {
        this.imageUploader.emit({
            src: this.src,
            meta: this.settings.meta,
        });
    }
    componentWillLoad() {
        let settings = this.__settings;
        if (typeof settings === 'string') {
            settings = JSON.parse(settings);
        }
        if (this.__value) {
            this.src = this.__value;
        }
        this.settings = utils.overrideSettings(this.settings, settings);
    }
    selectImage() {
        // @ts-ignore
        let wordpress = wp || null;
        console.log({ wordpress });
        if (wordpress) {
            let image_frame = wordpress.media({
                title: 'Select Image',
                multiple: false,
                library: {
                    type: 'image'
                }
            });
            image_frame.on('open', function () {
                var lastSelection = image_frame.state().get('selection');
                const attach = wordpress.media.attachment(lastSelection._single.id);
                if (attach) {
                    attach.fetch();
                }
                lastSelection.add(attach ? [attach] : []);
            });
            image_frame.on('select', function () {
                let selection = image_frame.state().get('selection');
                var metadata = image_frame.state().get('selection').first().toJSON();
                console.log({ selection, metadata });
                selection.each(function (attachment) {
                    let attrs = attachment["attributes"];
                    if (!attrs.alt) {
                        alert(`Alt text is required for ${attrs.filename} to select it.`);
                        image_frame.open();
                    }
                    else if (metadata.url) {
                        this.src = {
                            media_library: {
                                id: metadata.id,
                                src: metadata.url
                            }
                        };
                        this.emitData();
                    }
                }.bind(this));
            }.bind(this));
            image_frame.open();
        }
    }
    render() {
        var _a, _b;
        return (index.h("div", { key: '6a9d4819064cfa020972c5ebf4b13c135e532010' }, index.h("div", { key: '1abfff9dc6fa66edb5273806aa7cabbe8abc6ca4' }, index.h("button", { key: '6bf3c57dc5284f217e689ddd619290db66df5c39', type: "button", onClick: () => this.selectImage() }, "Select Image")), index.h("div", { key: 'e4f834402aeadb64d3c30b3af9c914977f6117f6', id: "image_uploader_preview" }, ((_b = (_a = this === null || this === void 0 ? void 0 : this.src) === null || _a === void 0 ? void 0 : _a.media_library) === null || _b === void 0 ? void 0 : _b.src) && index.h("img", { key: 'f4c88a4b35528f482ff29e12dddb06b08c9abe81', style: { maxHeight: '100%', maxWidth: '100%' }, src: this.src.media_library.src }))));
    }
};
FdiImageUploader.style = FdiImageUploaderStyle0;

const fdiMultiInputCss = "div.fdi.wc.multi-input-container{display:flex;flex-direction:column;border:solid 1px rgb(209, 213, 219);padding:0.25rem;justify-content:center}div.fdi.wc.multi-input-container div.input-container{display:flex;flex-direction:row;justify-content:center;align-items:center;column-gap:0.25rem}div.fdi.wc.multi-input-container button.add-button{align-items:center;padding:7px;border:solid 1px rgb(209, 213, 219)}div.fdi.wc.multi-input-container button.delete-button{align-items:center;padding:7px;border:solid 1px rgb(209, 213, 219)}";
const FdiMultiInputStyle0 = fdiMultiInputCss;

const FdiMultiInput = class {
    constructor(hostRef) {
        index.registerInstance(this, hostRef);
        this.multiInputChanged = index.createEvent(this, "fdi_wc_multi-input_change", 7);
        this.__inputs = '[]';
        this.__settings = undefined;
        this.inputs = undefined;
        this.settings = {
            inputSettings: {},
            containerStyle: {},
            containerClass: 'fdi wc multi-input-container',
            inputContainerStyle: {},
            inputContainerClass: 'input-container',
            buttonContainerStyle: {},
            buttonContainerClass: 'button-container',
            deleteButtonStyle: {},
            deleteButtonClass: 'delete-button',
            addButtonStyle: {},
            addButtonClass: 'add-button',
            meta: {},
        };
    }
    fdi_wc_input_change__handler(ev) {
        const { newValue, meta: { key } } = ev.detail;
        const existingInput = this.inputs.get(key);
        if (existingInput) {
            this.inputs.set(key, Object.assign(Object.assign({}, existingInput), { __value: newValue }));
        }
        this.emitValue();
    }
    emitValue() {
        const values = [];
        this.inputs.forEach(({ __value }) => {
            values.push(__value);
        });
        this.multiInputChanged.emit({
            newValue: values,
            meta: this.settings.meta,
        });
    }
    removeInput(key) {
        this.inputs.delete(key);
        this.emitValue();
        index.forceUpdate(this);
    }
    addInput(value = '') {
        const key = v4.v4();
        this.inputs.set(key, {
            style: { flexGrow: 1, display: 'flex' },
            __settings: Object.assign(Object.assign({}, this.settings.inputSettings), { meta: Object.assign(Object.assign({}, this.settings.inputSettings.meta), { key // Key used in our input handler
                }) }),
            __value: value
        });
        index.forceUpdate(this);
    }
    async componentWillLoad() {
        // Parse settings
        if (this.__settings) {
            let settings = this.__settings;
            if (typeof settings === 'string') {
                settings = JSON.parse(settings);
            }
            this.settings = utils.overrideSettings(this.settings, settings);
        }
        // Parse list of input strings and create input elements
        if (this.__inputs) {
            this.inputs = new Map();
            let inputs = this.__inputs;
            if (typeof inputs === 'string') {
                inputs = JSON.parse(inputs);
            }
            inputs.forEach(input => {
                this.addInput(input);
            });
        }
    }
    render() {
        const { containerClass, containerStyle, inputContainerClass, inputContainerStyle, buttonContainerClass, buttonContainerStyle, deleteButtonClass, deleteButtonStyle, addButtonClass, addButtonStyle } = this.settings;
        return (index.h("div", { key: 'cbcd1a0d3de4be8e99b95d02075d1031451ff249', class: containerClass, style: containerStyle }, [...this.inputs.entries()].map(([key, input]) => {
            return (index.h("div", { class: inputContainerClass, style: inputContainerStyle }, index.h("fdi-text-input", Object.assign({ id: key }, input)), index.h("div", { class: buttonContainerClass, style: buttonContainerStyle }, index.h("button", { onClick: () => this.removeInput(key), class: deleteButtonClass, style: deleteButtonStyle }, "Delete"))));
        }), index.h("button", { key: '02105750562a9bfbf311e7b7dd6e17098eca6c43', onClick: () => this.addInput(), class: addButtonClass, style: addButtonStyle }, "Add")));
    }
};
FdiMultiInput.style = FdiMultiInputStyle0;

const fdiMultiselectCss = ".fdi.wc.multiselect{position:relative;padding:0 !important;margin:0 !important}.fdi.wc.multiselect .menu{width:100%;padding:5px}.fdi.wc.multiselect .menu div{margin-right:5px;display:inline-block;padding:2px;cursor:pointer;color:#4e4e4e;font-size:15px}.fdi.wc.multiselect .menu div:hover{text-decoration:underline}.fdi.wc.multiselect #optionsContainer{position:absolute;background:white;outline:solid 1px #ccc;overflow-y:auto}.fdi.wc.multiselect #optionsContainer .option{padding:0 5px}.fdi.wc.multiselect #optionsContainer .option span{width:100%;height:100%}.fdi.wc.multiselect #optionsContainer .option:hover{background:#f3f3f3;cursor:pointer}.fdi.wc.multiselect #optionsContainer .option.selected{background:#cccccc;color:#ececec}.fdi.wc.multiselect #selectedContainer{padding:5px;display:flex}.fdi.wc.multiselect #selectedContainer .removeSelected{float:left;margin:0 5px}.fdi.wc.multiselect #selectedContainer .removeSelected:hover{cursor:pointer}.fdi.wc.multiselect #selectedContainer .selectedContent{text-overflow:ellipsis;overflow:hidden;white-space:nowrap}.fdi.wc.multiselect #selectedContainer .selected.list-mode{padding:1px 5px}.fdi.wc.multiselect #selectedContainer .selected.tag-mode{max-width:40%;display:inline-flex;border:solid 1px;border-color:#c78203;border-radius:5px;margin:5px 5px 0 0;padding:2px;background:orange;color:white}";
const FdiMultiselectStyle0 = fdiMultiselectCss;

const FDIMultiselect = class {
    constructor(hostRef) {
        index.registerInstance(this, hostRef);
        this.multiselectChanged = index.createEvent(this, "fdi_wc_multiselect_change", 7);
        this.__value = '';
        this.__settings = undefined;
        this.__opts = [];
        this.__selected = undefined;
        this.inputValue = '';
        this.inputFocused = false;
        this.selected = [];
        this.opts = [];
        this.showOptions = false;
        this.settings = {
            disabled: false,
            tagMode: true,
            sortOptions: true,
            selectAllButton: {
                text: 'Select All',
                enabled: true,
                style: {
                    outline: 'solid 1px #ccc',
                    background: 'white',
                    color: '#5f5f5f'
                }
            },
            removeAllButton: {
                text: 'Remove All',
                enabled: true,
                style: {
                    outline: 'solid 1px #ccc',
                    background: 'white',
                    color: '#5f5f5f'
                }
            },
            addCustomButton: {
                text: 'Add Custom Value',
                enabled: true,
                style: {
                    outline: 'solid 1px #ccc',
                    background: 'white',
                    color: '#5f5f5f'
                }
            },
            tooltipEnabled: false,
            singleSelect: false,
            defaults: [],
            style: {
                general: {
                    fontSize: '15px',
                    maxWidth: '100%',
                    width: '100%',
                    margin: 0,
                    outline: '1px solid #ccc',
                    background: 'white',
                },
                optionSelection: {
                    width: '100%',
                    maxHeight: '200px',
                },
            },
            input: {
                placeholder: 'Enter Value',
                fontSize: '15px',
            },
            meta: {},
        };
    }
    fdi_wc_input_change__handler(ev) {
        let data = ev.detail;
        this.inputValue = data.newValue;
    }
    handleKeyDown(ev) {
        if (ev.key === 'Enter' && this.inputFocused) {
            this.addCustomValue();
        }
    }
    emitData() {
        let selected = this.selected.map((selected) => {
            return this.isObj(selected) ? selected.value : selected;
        });
        this.multiselectChanged.emit({
            newValue: selected,
            meta: this.settings.meta,
        });
    }
    onInputFocus() {
        this.showOptions = true;
        this.inputFocused = true;
    }
    onInputBlur() {
        setTimeout(() => {
            this.showOptions = false;
            this.inputFocused = false;
        }, 250);
    }
    inSelected(o) {
        for (const selected of this.selected) {
            if (JSON.stringify(selected) === JSON.stringify(o)) {
                return true;
            }
        }
        return false;
    }
    inOpts(val) {
        for (const [i, opt] of this.opts.entries()) {
            let optVal = this.isObj(opt) ? opt.value : opt;
            if (optVal === val) {
                return i;
            }
        }
        return -1;
    }
    optionsClickHandler(o) {
        if (!this.inSelected(o)) {
            if (this.settings.singleSelect) {
                this.selected = [
                    ...[o]
                ];
            }
            else {
                this.selected = [
                    ...this.selected,
                    ...[o]
                ];
            }
            this.emitData();
        }
    }
    selectAllOpts() {
        this.selected = [
            ...this.opts
        ];
        this.emitData();
    }
    removeAllOpts() {
        this.selected = [
            ...[]
        ];
        this.emitData();
    }
    removeSelectionHandler(i) {
        let selectedArr = this.selected;
        selectedArr.splice(i, 1);
        this.selected = [...selectedArr];
        this.emitData();
    }
    addCustomValue() {
        if (this.inputValue && !this.inSelected(this.inputValue)) {
            if (this.settings.singleSelect) {
                this.selected = [
                    ...[this.inputValue],
                ];
            }
            else {
                this.selected = [
                    ...this.selected,
                    ...[this.inputValue],
                ];
            }
            this.emitData();
        }
    }
    componentWillLoad() {
        let settings = this.__settings;
        let selected = this.__selected;
        let opts = this.__opts;
        if (typeof settings === 'string') {
            settings = JSON.parse(settings);
        }
        if (typeof selected === 'string') {
            selected = JSON.parse(selected);
        }
        if (typeof opts === 'string') {
            opts = JSON.parse(opts);
        }
        this.settings = utils.overrideSettings(this.settings, settings);
        selected = selected || [];
        selected = selected.filter((s) => {
            return s !== null && s !== undefined && s.toString().trim() !== '';
        });
        this.selected = [
            ...(selected || [])
        ];
        if (this.settings.sortOptions) {
            opts.sort((a, b) => {
                a = String(a).toUpperCase();
                b = String(b).toUpperCase();
                if (a > b)
                    return 1;
                if (a < b)
                    return -1;
                return 0;
            });
        }
        this.opts = [
            ...(opts || [])
        ];
        let defaults = Object.values(this.settings.defaults || []) || [];
        let defaultsLength = defaults.length;
        let originalSelectedLength = this.selected.length;
        this.selected.forEach((selected, i) => {
            let selectedIdx = this.inOpts(selected);
            if (selectedIdx > -1) {
                this.selected.splice(i, 1);
                this.selected = [
                    ...this.selected,
                    ...[this.opts[selectedIdx]]
                ];
            }
            else {
                this.opts = [
                    ...this.opts,
                    ...[selected],
                ];
            }
        });
        for (const opt of this.opts) {
            let optVal = this.isObj(opt) ? opt.value : opt;
            if (originalSelectedLength === 0 && defaultsLength > 0 && defaults.includes(optVal)) {
                this.selected = [
                    ...this.selected,
                    ...[opt],
                ];
            }
        }
        this.emitData();
    }
    isObj(variable) {
        return {}.toString.call(variable) === '[object Object]' && variable !== null;
    }
    render() {
        let optionSelectionSettings = Object.assign(Object.assign({}, this.settings.style.optionSelection), {
            display: this.showOptions ? 'block' : 'none',
        });
        /**
         * Set the choices.
         */
        let options = this.opts.map((op) => {
            let isObject = this.isObj(op);
            let opVal = isObject ? op.value : op;
            let opDisplay = isObject ? op.display : op;
            if (this.inputValue) {
                if (!opVal.toLowerCase().includes(this.inputValue.toLowerCase()))
                    return;
            }
            let optionClasses = ['option'];
            if (this.inSelected(op)) {
                optionClasses.push('selected');
            }
            return (index.h("div", { onClick: () => this.optionsClickHandler(op), class: optionClasses.join(' ') }, index.h("span", { innerHTML: opDisplay }, " ")));
        });
        /**
         * Set the menu.
         */
        let menu = '';
        if (!this.settings.disabled) {
            menu = (index.h("div", { class: 'menu' }, !this.settings.singleSelect && this.opts.length > 0 && this.settings.selectAllButton.enabled &&
                index.h("div", { onClick: () => this.selectAllOpts(), style: this.settings.selectAllButton.style }, this.settings.selectAllButton.text), this.settings.removeAllButton.enabled && this.selected.length > 0 &&
                index.h("div", { onClick: () => this.removeAllOpts(), style: this.settings.removeAllButton.style }, this.settings.removeAllButton.text), this.settings.addCustomButton.enabled && this.inputValue &&
                index.h("div", { onClick: () => this.addCustomValue(), style: this.settings.addCustomButton.style }, this.settings.addCustomButton.text)));
        }
        let optionSelection = (index.h("div", { id: 'optionsContainer', style: optionSelectionSettings }, options));
        let selectedChoices = this.selected.map((selected, i) => {
            let selectedClasses = [
                'selected',
            ];
            let isObj = this.isObj(selected);
            this.settings.tagMode ? selectedClasses.push('tag-mode') : selectedClasses.push('list-mode');
            let tooltipSettings = {
                tooltipText: isObj ? (selected.tooltip || selected.display) : selected,
            };
            return (index.h("div", { class: selectedClasses.join(' ') }, this.settings.tooltipEnabled &&
                index.h("fdi-tooltip", { key: v4.v4(), __settings: tooltipSettings }), !this.settings.disabled &&
                index.h("div", { onClick: () => this.removeSelectionHandler(i), class: 'removeSelected', innerHTML: '&times;' }), index.h("div", { class: 'selectedContent' }, isObj ? selected.display : selected)));
        });
        let selectedContainerStyle = {
            flexFlow: this.settings.tagMode ? 'wrap' : 'column',
        };
        let selected = (index.h("div", { id: 'selectedContainer', style: selectedContainerStyle }, selectedChoices));
        return (index.h("div", { class: 'fdi wc multiselect', style: this.settings.style.general }, !this.settings.disabled &&
            index.h("div", null, index.h("fdi-text-input", { onBlur: () => { this.onInputBlur(); }, onFocus: () => { this.onInputFocus(); }, __settings: this.settings.input })), menu, optionSelection, selected));
    }
};
FDIMultiselect.style = FdiMultiselectStyle0;

exports.fdi_date_time_picker = FdiDateTimePicker;
exports.fdi_image_uploader = FdiImageUploader;
exports.fdi_multi_input = FdiMultiInput;
exports.fdi_multiselect = FDIMultiselect;

//# sourceMappingURL=fdi-date-time-picker_4.cjs.entry.js.map