'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

const index = require('./index-3c56ce3c.js');
const appGlobals = require('./app-globals-3a1e7e63.js');

/*
 Stencil Client Patch Browser v4.20.0 | MIT Licensed | https://stenciljs.com
 */
var patchBrowser = () => {
  const importMeta = (typeof document === 'undefined' ? new (require('u' + 'rl').URL)('file:' + __filename).href : (document.currentScript && document.currentScript.src || new URL('webcomponents.cjs.js', document.baseURI).href));
  const opts = {};
  if (importMeta !== "") {
    opts.resourcesUrl = new URL(".", importMeta).href;
  }
  return index.promiseResolve(opts);
};

patchBrowser().then(async (options) => {
  await appGlobals.globalScripts();
  return index.bootstrapLazy([["fdi-wizards.cjs",[[1,"fdi-wizards",{"__wizards":[1],"__displayFields":[1,"__display-fields"],"__title":[1],"__templateId":[1,"__template-id"],"id":[32],"wizards":[32],"displayFields":[32],"activeWizard":[32]},[[0,"fdi_wc_wizardCompleted","fdi_wc_input_change__handler"]]]]],["fdi-sortable.cjs",[[1,"fdi-sortable",{"__settings":[8],"__items":[8],"items":[32],"dataMap":[32],"data":[32],"mainSortable":[32],"innerSortables":[32],"uuid":[32],"settings":[32]},[[0,"fdi_wc_input_change","fdi_wc_input_change__handler"]]]]],["fdi-container.cjs",[[1,"fdi-container",{"__settings":[8],"settings":[32],"collapsed":[32]}]]],["my-component.cjs",[[0,"my-component",{"first":[1],"middle":[1],"last":[1]}]]],["fdi-text-input_2.cjs",[[1,"fdi-tooltip",{"__settings":[8],"__html":[1],"id":[32],"displayTooltip":[32],"settings":[32]}],[1,"fdi-text-input",{"__value":[1],"__settings":[8],"uuid":[32],"value":[32],"oldValue":[32],"settings":[32]}]]],["fdi-date-time-picker_4.cjs",[[1,"fdi-multiselect",{"__value":[1],"__settings":[8],"__opts":[8],"__selected":[8],"inputValue":[32],"inputFocused":[32],"selected":[32],"opts":[32],"showOptions":[32],"settings":[32]},[[0,"fdi_wc_input_change","fdi_wc_input_change__handler"],[4,"keydown","handleKeyDown"]]],[1,"fdi-multi-input",{"__inputs":[8],"__settings":[8],"inputs":[32],"settings":[32]},[[0,"fdi_wc_input_change","fdi_wc_input_change__handler"]]],[1,"fdi-date-time-picker",{"__settings":[8],"__datetime":[1],"__dateonly":[4],"picker":[32],"date":[32],"time":[32],"station":[32],"timezone":[32],"settings":[32]}],[1,"fdi-image-uploader",{"__settings":[8],"__value":[8],"src":[32],"settings":[32]}]]],["fdi-wizard.cjs",[[1,"fdi-wizard",{"__targetFI":[1,"__target-f-i"],"__ajaxUrl":[1,"__ajax-url"],"__templateId":[1,"__template-id"],"__existingAnswers":[1,"__existing-answers"],"__wizardId":[1,"__wizard-id"],"__master":[1],"wizardId":[32],"wizard":[32],"templateLoaded":[32],"noTemplateText":[32],"wizardComplete":[32],"currentQuestionIndexes":[32],"searchQuery":[32],"slides":[32],"currentSlide":[32],"existingAnswers":[32],"renderTrigger":[32],"multiSelectOptions":[32],"textInputValues":[32]},[[0,"fdi_wc_input_change","fdi_wc_input_change__handler"],[0,"fdi_wc_multi-input_change","fdi_wc_multiInput_change__handler"],[0,"fdi_wc_multiselect_change","fdi_wc_multiselect_change__handler"],[0,"fdi_wc_datetimepicker_change","fdi_wc_datetimepicker_change__handler"],[0,"fdi_wc_image_uploader_load","fdi_wc_image_uploader_load__handler"]]]]]], options);
});

exports.setNonce = index.setNonce;

//# sourceMappingURL=webcomponents.cjs.js.map