import { EventEmitter } from '../../stencil-public-runtime';
export declare class FDIWizard {
    __targetFI: string;
    __ajaxUrl: string;
    __templateId: string;
    __existingAnswers: string;
    __wizardId: string;
    __master: string;
    wizardId: string;
    wizard: any;
    templateLoaded: boolean;
    noTemplateText: string;
    wizardComplete: boolean;
    currentQuestionIndexes: Array<number>;
    searchQuery: string;
    slides: Array<any>;
    currentSlide: number;
    existingAnswers: any;
    renderTrigger: boolean;
    multiSelectOptions: any;
    textInputValues: any;
    wizardCompleted: EventEmitter;
    finish(): void;
    fdi_wc_input_change__handler(ev: any): void;
    fdi_wc_multiInput_change__handler(ev: any): void;
    fdi_wc_multiselect_change__handler(ev: any): void;
    fdi_wc_datetimepicker_change__handler(ev: any): void;
    fdi_wc_image_uploader_load__handler(ev: any): void;
    addCustomAnswer(idx: any, id: any): void;
    addAllSelections(question: any): void;
    removeAllSelections(question: any): void;
    removeAnswer(idx: any, answers: any): void;
    showAnswers(question: any): void;
    hideAnswers(question: any): void;
    processExistingAnswers(): void;
    loadSlides(): void;
    goToInitialSlide(): void;
    loadTemplate(): Promise<void>;
    moveToSlideContainingIndex(idx: any): void;
    skipToFriendlyIndex(fi: any): void;
    matchesSearchQuery(string: any): true | RegExpMatchArray;
    moveToSlide(idx: any): void;
    nextSlide(): void;
    prevSlide(): void;
    componentWillLoad(): Promise<void>;
    handleAnswer(e: any, i: any): void;
    render(): any;
}
